#!/usr/bin/perl

##############################################################################
# virmeld.pl (C) J. Fiebig <superlehrer@gmx.de>                             #
# This script is free software. You may redistribute and/or modify  it under #
# the terms and conditions of the GNU General Public License, Version 2      #
#                                                                            #
# There is NO WARRANTY on anything!                                          #
#                                  					     #
# Das Script beruht auf dem Quelltext des Scriptes smbstatus2html.pl fr     #
# Arktur 3 von Rene van Bevern                                               #
##############################################################################
# Das Script setzt eine Installation von Bitdefender vorraus.                #
# Dabei sollte bitdefender in /opt/bdc/ liegen, damit die Signaturen in      #
# /opt/bdc/Plugins/ gefunden werden knnen.                                  #
# Der Aufruf von Bitdefender muss die Standardausgaben nach                  #
# /var/log/bdc.log schreiben.                                                #
# Dies gelingt z.B. mit:  bdc /home --all --disinfect > /var/log/bdc.log     #
# in der crontab.                                                            #
# Ein Start vom Script aus ist nicht sinnvoll, da der Scan lange dauern kann #
##############################################################################

# $Id: virmeld.pl,v 1.2 2005/10/15 16:29:39 HHullen Exp $
# $Log: virmeld.pl,v $
# Revision 1.2  2005/10/15 16:29:39  HHullen
# allg. Hostname
#
# Versionsnummer von Arktur angepasst
#
# Revision 1.1  2005/10/15 16:21:28  JFiebig
# Start
#

# Hier wird konfiguriert ber welche Datei der Datenaustausch gemacht wird

$log_file = "/var/log/bdc.log";
$date = `/bin/date \"+%T %e.%m.%Y\"`;
my $host = `hostname -i`;
# Anregung von Martin Hlsmann, umgesetzt von H.-D. Kirmse


open LOG_OUTPUT, '<'.$log_file;
@log_output = <LOG_OUTPUT>;
close (LOG_OUTPUT);

$update_file = "/tmp/bdc.update";
system "ls -l -t --time-style=+%d.%t%m.%t%Y%t-%t%k:%M /opt/bdc/Plugins/*.* > /tmp/bdc.update";
# system "ls -l -t --time-style=+%k:%M /opt/bdc/Plugins/*.* > /tmp/bdc.update";

open UPDATE_OUTPUT, '<'.$update_file;
@update_output = <UPDATE_OUTPUT>;
close (UPDATE_OUTPUT);


$date_file = "/tmp/bdc.date";
system "ls -l --time-style=+%d.%t%m.%t%Y%tgegen%t%k:%M /var/log/bdc.log > /tmp/bdc.date";
open DATE_OUTPUT, '<'.$date_file;
@date_output = <DATE_OUTPUT>;
close (DATE_OUTPUT);



print "Content-type: text/html\n\n";
print "<HTML><BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\"\
BACKGROUND=\"/online/whttxtr2.jpg\"><FONT SIZE=\"-1\">Datum: $date</FONT><BR><BR>\n";

foreach $line (@date_output)
{
	@fields = split(/ +/,$line);
	print "<FONT SIZE=\"+2\">Ergebnisse des letzten Virenscanns vom $fields[5] Uhr :</FONT><BR>"; 
	eo_foreach:
}

$Anzahl=0;
foreach $line (@update_output)
{
	if ($Anzahl==0)
	{@fields = split(/ +/,$line);
	 print "<FONT SIZE=\"-1\">Virensignaturen vom $fields[5] Uhr </FONT><BR><BR>";
	 $Anzahl=1; 
	} 
	eo_foreach:
}


$Anzahl=0;

foreach $line (@log_output)
{
	if($line=~/infected:/) {$Anzahl=$Anzahl+1 ; goto eo_foreach;}
	eo_foreach:
}

print "<FONT SIZE=\"+1\"> <STRONG>";
if ($Anzahl==0) {print "<FONT SIZE=\"+2\" style=\"color: rgb(51, 205, 0);\">\
                 Ihr System ist virenfrei!<BR></FONT></FONT><BR>\
		 Alle Meldungen:<FONT SIZE=\"+1\"><BR>"} else
{
print "<FONT style=\"color: rgb(0, 0, 255);\">";
if ($Anzahl==1) {print "Es wurde ein Virus gefunden!<BR><BR>";} else 
{print "Es wurden $Anzahl Viren gefunden!<BR><BR>";}
print "</FONT>";
}
print "</STRONG></FONT>";

foreach $line (@log_output)
{
	if($line=~/^\s*$/) {goto eo_foreach;}
	if($line=~/Copyright/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/00000000/) {goto eo_foreach;}	
#	if($line=~/Console/) {goto eo_foreach;}	
	if($line=~/Results/) {goto eo_foreach;}
	if($line=~/packed with/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/generic unpacked/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/disinfection failed/) {print "$line - Lschen Sie selbst oder nutzen Sie die Option --delete<BR>"; goto eo_foreach;}
	if($line=~/deleted/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/no scan option/) {print "$line<BR>"; goto eo_foreach;}	
	if($line=~/copied/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/infected:/) {print "<FONT SIZE=\"+1\" style=\"color: rgb(255, 0, 0);\">$line</FONT><BR>"; goto eo_foreach;}
	if($line=~/Folders/) {print "<br><br>Gescannt wurden:<br>$line &nbsp&nbsp;"; goto eo_foreach;}	
	if($line=~/Infected/) {print "<FONT style=\"color: rgb(0, 0, 255);\">$line</FONT> &nbsp&nbsp;"; goto eo_foreach;}
	if($line=~/Suspect/) {print "<FONT style=\"color: rgb(51, 205, 0);\">$line</FONT> &nbsp&nbsp;"; goto eo_foreach;}
	if($line=~/viruses/) {print "<FONT style=\"color: rgb(0, 0, 255);\">$line</FONT> &nbsp&nbsp;"; goto eo_foreach;}
	print "$line<br>";
	eo_foreach:
}
 print "<BR>";



print "<br><br><br><FONT SIZE=\"-1\">\
virmeld.pl - Version 0.9 (C) August 2005,<BR>\
fr Arktur 3.4 von <A HREF=\"mailto:superlehrer@gmx.de\">J. Fiebig</A> vom\
<A HREF=\"http://www.Erzgebirgskolleg.de\">Erzgebirgskolleg Breitenbrunn</A>.\
</FONT><BR></BODY></HTML>";

system "rm -f /tmp/bdc.date";
system "rm -f /tmp/bdc.update";

exit 1;
